<?php
/**
*
* @author	 	CHItA (Mt Bartus) <bartus.mate@root.hu>
* @package 		umil
* @version 		$Id: autolink_install.php 43 2010-07-20 14:11:44Z CHItA $
* @copyright 	(c) 2010 Mate Bartus
* @license 		http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
define('UMIL_AUTO', true);
define('IN_PHPBB', true);
$phpbb_root_path = (defined('PHPBB_ROOT_PATH')) ? PHPBB_ROOT_PATH : './';
$phpEx = substr(strrchr(__FILE__, '.'), 1);
include($phpbb_root_path . 'common.' . $phpEx);
$user->session_begin();
$auth->acl($user->data);
$user->setup();

if (!file_exists($phpbb_root_path . 'umil/umil_auto.' . $phpEx))
{
	trigger_error('Please download the latest UMIL (Unified MOD Install Library) from: <a href="http://www.phpbb.com/mods/umil/">phpBB.com/mods/umil</a>', E_USER_ERROR);
}

$mod_name = 'AUTOLINK_MOD';
$version_config_name = 'autolinkmod_version';
$language_file = 'mods/info_acp_autolink';

$versions = array(
	// Version 1.0.1
	'1.0.1' => array(
		'config_add' => array(
			array('autolink_replace_times_in_a_post', 1),
			array('autolink_max_num_of_a_word', 5)
		),
		
		'table_add' => array(
			array('phpbb_autolink_words', array(
				'COLUMNS' => array(
					'autolink_id' => array('UINT:12', NULL, 'auto_increment'),
					'autolink_word' => array('VCHAR', ''),
					'autolink_url' => array('VCHAR', ''),
					'autolink_rate' => array('VCHAR:25', ''),
					'autolink_word_lang' => array('UINT:3', 0),
					),
				'PRIMARY_KEY'	=> 'autolink_id',
				'KEYS'		=> array()
				)
			)
		),
		
		'module_add' => array(
			array('acp', 10, array(
				'module_basename' => 'autolink',
				'module_langname' => 'Autolink MOD'
				)
			)
		)
	),
	
	// Version 1.0.2
	'1.0.2' => array(
		'module_remove' => array(
			array('acp', 10, 'Autolink MOD')
		),
		
		'module_add' => array(
			array('acp', 10, array(
				'module_basename' => 'autolink',
				'module_langname' => 'AUTOLINK_MOD'
				)
			)
		)
	),
	
	// Version 1.0.3
	'1.0.3' => array(),
);

include($phpbb_root_path . 'umil/umil_auto.' . $phpEx);

?>