<?php
/**
 *
 * @package	Autolink MOD ACP
 * @author	Mt Bartus <bartus.mate@root.hu>
 * @version	$Id: acp_autolink.php 44 2010-07-20 14:12:51Z CHItA $
 *
 **/

if (!defined('IN_PHPBB'))
{
    exit;
}

class acp_autolink
{
	var $u_action;
	var $tpl_path;
	var $page_title;
	
	function main($id, $mode)
	{
		global $db, $user, $template, $cache;
		global $config;
		
		$this->tpl_name = 'acp_autolink';
		$this->page_title = 'ACP_AUTOLINK';
		
		$action = request_var('action', '', true);
		$update_action = false;

		switch ($action)
		{
			case 'edit':
				// Get the ID of the item we would like to edit
				$word_id = request_var('edit_id', 0);			
				if ($word_id == 0)
				{
					trigger_error($user->lang['AUTOLINK_INVALID_ID'] . adm_back_link($this->u_action), E_USER_WARNING);
				}
				
				// Query the data of the item
				$sql = 'SELECT * FROM ' . AUTOLINK_MOD_WORDS_TABLE . ' WHERE autolink_id = ' . $word_id;
				$result = $db->sql_query($sql);
				$row = $db->sql_fetchrow($result);
				$db->sql_freeresult($result);

				$template->assign_vars(array(
					'S_WORD'	=> $row['autolink_word'],
					'S_URL'		=> $row['autolink_url'],
					'S_RATE'	=> $row['autolink_rate'])
					);
				$update_action = true;
			// break; don't needed
			case 'add':
				// Create the language list
				$sql = 'SELECT * FROM ' . LANG_TABLE;
				$result = $db->sql_query($sql);
				while ($row = $db->sql_fetchrow($result))
				{
					$template->assign_block_vars('autolink_lang_option', array(
						'S_OPTION_VALUE'	=> $row['lang_id'],
						'LANG_NAME'		=> $row['lang_local_name'])
						);
				}
				$db->sql_freeresult($result);
				
				$template->assign_vars(array(
					'U_W_ACTION'	=> ( ($action == 'edit') ? $this->u_action . '&amp;action=edit&amp;edit_id=' . $word_id : $this->u_action . '&amp;action=add'),
					'S_ADD_PAGE'	=> true)
					);
				
				add_form_key('acp_autolinkword');
				
				if (isset($_POST['submit']))
				{
					$sql_array = array(
						'autolink_word'			=> utf8_normalize_nfc(request_var('autolink_word', '', true)),
						'autolink_url'			=> request_var('autolink_url', '', true),
						'autolink_rate'			=> request_var('autolink_rate', '', true),
						'autolink_word_lang'	=> request_var('autolink_lang', 0)
						);	
						
					if ($action == 'edit')
					{
						$sql = 'UPDATE ' . AUTOLINK_MOD_WORDS_TABLE . ' SET '
							. $db->sql_build_array('UPDATE', $sql_array) . " 
							WHERE autolink_id = $word_id";
						
						$log_msg = sprintf($user->lang['LOG_AUTOLINK_WORD_EDIT'], $sql_array['autolink_word']);
					}
					else
					{						
						$sql = 'INSERT INTO ' . AUTOLINK_MOD_WORDS_TABLE . ' ' . $db->sql_build_array('INSERT', $sql_array);

						$log_msg = sprintf($user->lang['LOG_AUTOLINK_WORD_ADDED'], $sql_array['autolink_word']);
					}
					
					$errors = $this->input_check($sql_array, check_form_key('acp_autolinkword'), $update_action);
					if ($errors === true)
					{
						$db->sql_query($sql);
						add_log('admin', $log_msg);							
						$cache->destroy('sql', AUTOLINK_MOD_WORDS_TABLE);
						trigger_error($log_msg . adm_back_link($this->u_action));				
					}
					else
					{
						for ($i = 0; $i < sizeof($errors); $i++)
						{
							$template->assign_block_vars('error', array(
								'ERROR_MSG' => $errors[$i])
								);
						}
						
						$template->assign_var('S_ERROR_FORM', true);
					}
				}
			break;
			case 'delete':
				$word_id = request_var('delete_id', 0);
				
				if ($word_id == 0)
				{
					trigger_error($user->lang['AUTOLINK_INVALID_ID'] . adm_back_link($this->u_action), E_USER_WARNING);
				}
				else
				{
					if (confirm_box(true))
					{
						$sql = 'SELECT * FROM ' . AUTOLINK_MOD_WORDS_TABLE . ' WHERE autolink_id = ' . $word_id;
						$result = $db->sql_query($sql);
						$row = $db->sql_fetchrow($result);
						$db->sql_freeresult($result);
						
						$log_msg = sprintf($user->lang['LOG_AUTOLIMK_WORD_DELETE'], $row['autolink_word']);
						
						$sql = 'DELETE FROM ' . AUTOLINK_MOD_WORDS_TABLE . ' WHERE autolink_id = ' . $word_id;
						$db->sql_query($sql);
						add_log('admin', $log_msg);
						$cache->destroy('sql', AUTOLINK_MOD_WORDS_TABLE);
						trigger_error($log_msg . adm_back_link($this->u_action));
					}
					else
					{
						confirm_box(false, $user->lang['CONFIRM_OPERATION'], build_hidden_fields(array(
							'i'		=> $id,
							'mode'		=> $mode,
							'delete_id'	=> $word_id,
							'action'	=> 'delete',
						)));				
					}
				}			
			break;
			default:
				if (isset($_POST['submit']))
				{
					set_config('autolink_replace_times_in_a_post', request_var('autolink_max_post', 1));
					set_config('autolink_max_num_of_a_word', request_var('autolink_max_word', 5)); 
					add_log('admin', 'LOG_AUTOLINK_CONFIG_UPDATED');
					trigger_error($user->lang['LOG_AUTOLINK_CONFIG_UPDATED'] . adm_back_link($this->u_action));
				}			
				
				$sql = 'SELECT a.*, l.lang_local_name AS lang_name 
						FROM ' . AUTOLINK_MOD_WORDS_TABLE . ' a
						LEFT JOIN ' . LANG_TABLE . ' l 
						ON l.lang_id = a.autolink_word_lang'; 
				$result = $db->sql_query($sql);
				while ($row = $db->sql_fetchrow($result))
				{
					$template->assign_block_vars('autolinks', array(
						'NAME'			=> $row['autolink_word'],
						'URL'			=> $row['autolink_url'],
						'RATE'			=> $row['autolink_rate'],
						'LANG'			=> ( (empty($row['lang_name']) || !isset($row['lang_name'])) ? $user->lang['ACP_AUTOLINK_LANG_ALL'] : $row['lang_name'] ),
						'U_EDIT'		=> $this->u_action . '&amp;action=edit&amp;edit_id=' . $row['autolink_id'],
						'U_DELETE'		=> $this->u_action . '&amp;action=delete&amp;delete_id=' . $row['autolink_id']
						)
					);
				}
				$db->sql_freeresult($result);
				
				$template->assign_vars(array(
					'S_WORDS_MAX_POST'		=> (int) $config['autolink_replace_times_in_a_post'],
					'S_MAX_WORD'			=> (int) $config['autolink_max_num_of_a_word'],
					'S_CONFIG_PAGE'			=> true)
					);				
			break;
		}
		
		$template->assign_vars(array(
			'U_ADD'				=> $this->u_action . '&amp;action=add',
			'U_ACTION'			=> $this->u_action)
		);		
	}
	
	function input_check($input_array, $key_error = false, $update = false)
	{
		global $db, $user;
		
		if (!$key_error)
		{
			$errors[] = $user->lang['INVALID_FORM_KEY'];
		}
		
		if (empty($input_array['autolink_word']))
		{
			$errors[] = $user->lang['AUTOLINK_EMPTY_WORD_FIELD'];
		}
		else
		{
			$sql = 'SELECT COUNT(*) AS num 
					FROM ' . AUTOLINK_MOD_WORDS_TABLE . ' 
					WHERE lower(autolink_word) = "' . utf8_strtolower($db->sql_escape($input_array['autolink_word'])) . '"';
			$result = $db->sql_query($sql);
			$word_stored_num = (int) $db->sql_fetchfield('num');
			$db->sql_freeresult($result);
			
			if ($word_stored_num != 0 && !$update)
			{
				$errors[] = $user->lang['AUTOLINK_WORD_ALREADY_EXIST'];
			}
		}
		
		if (empty($input_array['autolink_url']))
		{
			$errors[] = $user->lang['AUTOLINK_EMPTY_URL_FIELD'];
		}
		
		if (strpos($input_array['autolink_url'], '|') !== false)
		{
			$url_parts = explode('|', $input_array['autolink_url']);
			$rate_parts = explode(':', $input_array['autolink_rate']);
			
			if (sizeof($url_parts) != sizeof($rate_parts))
			{
				$errors[] = $user->lang['AUTOLINK_DIFFERENT_SIZE_ARRAY'];
			}
		}
		
		$ret = (empty($errors)) ? true : $errors;
		return ($ret);
	}
}	
?>